Debian Bug report logs - #630228
foo2zjs: Firmware upload is not compatible with cups

version graph

Package: foo2zjs; Maintainer for foo2zjs is Debian Printing Team <debian-printing@lists.debian.org>; Source for foo2zjs is src:foo2zjs.

Reported by: Peter De Wachter <pdewacht@gmail.com>

Date: Sun, 12 Jun 2011 13:54:02 UTC

Severity: serious

Merged with 630227

Found in version foo2zjs/20110210dfsg-2

Fixed in version foo2zjs/20110722dfsg-1

Done: Didier Raboud <odyx@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Sun, 12 Jun 2011 13:54:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Peter De Wachter <pdewacht@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Sun, 12 Jun 2011 13:54:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Peter De Wachter <pdewacht@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: foo2zjs: Firmware upload is not compatible with cups
Date: Sun, 12 Jun 2011 15:40:09 +0200
Package: foo2zjs
Version: 20110210dfsg-2
Severity: serious

The latest cups upload blacklisted the usblp kernel module, but foo2zjs'
firmware upload scripts need that module to function. Would it be difficult
to rewrite the firmware scripts to use raw usb devices?

-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.38-2-amd64 (SMP w/2 CPU cores)
Locale: LANG=nl_BE.UTF-8, LC_CTYPE=nl_BE.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages foo2zjs depends on:
ii  cups                          1.4.6-8    Common UNIX Printing System(tm) - 
ii  cups-client                   1.4.6-8    Common UNIX Printing System(tm) - 
ii  dc                            1.06.95-2  The GNU dc arbitrary precision rev
ii  foomatic-filters              4.0.7-1    OpenPrinting printer support - fil
ii  libc6                         2.13-6     Embedded GNU C Library: Shared lib
ii  libcups2                      1.4.6-8    Common UNIX Printing System(tm) - 

Versions of packages foo2zjs recommends:
ii  foomatic-db-engine            4.0.7-2    OpenPrinting printer support - pro
ii  unzip                         6.0-4      De-archiver for .zip files
ii  wget                          1.12-3.1   retrieves files from the web

Versions of packages foo2zjs suggests:
pn  hannah-foo2zjs                <none>     (no description available)
ii  psutils                       1.17-29    A collection of PostScript documen
pn  tix                           <none>     (no description available)
pn  tk8.4                         <none>     (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Sun, 12 Jun 2011 14:06:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Didier Raboud <odyx@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Sun, 12 Jun 2011 14:06:05 GMT) Full text and rfc822 format available.

Message #10 received at 630228@bugs.debian.org (full text, mbox):

From: Didier Raboud <odyx@debian.org>
To: Peter De Wachter <pdewacht@gmail.com>
Cc: 630228@bugs.debian.org, cups@packages.qa.debian.org
Subject: Re: Bug#630228: foo2zjs: Firmware upload is not compatible with cups
Date: Sun, 12 Jun 2011 16:03:58 +0200
Le dimanche, 12 juin 2011 15.40:09, Peter De Wachter a écrit :
> Package: foo2zjs
> Version: 20110210dfsg-2
> Severity: serious
> 
> The latest cups upload blacklisted the usblp kernel module, but foo2zjs'
> firmware upload scripts need that module to function. Would it be difficult
> to rewrite the firmware scripts to use raw usb devices?

I'm hereby CC'ing the CUPS maintainers; opinions ?

Cheers,

-- 
OdyX




Forcibly Merged 630227 630228. Request was from Didier Raboud <odyx@debian.org> to control@bugs.debian.org. (Sun, 12 Jun 2011 14:06:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Sun, 12 Jun 2011 14:24:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Till Kamppeter <till.kamppeter@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Sun, 12 Jun 2011 14:24:06 GMT) Full text and rfc822 format available.

Message #17 received at 630228@bugs.debian.org (full text, mbox):

From: Till Kamppeter <till.kamppeter@gmail.com>
To: Didier Raboud <odyx@debian.org>, 630228@bugs.debian.org
Cc: Peter De Wachter <pdewacht@gmail.com>, cups@packages.qa.debian.org
Subject: Re: Bug#630228: foo2zjs: Firmware upload is not compatible with cups
Date: Sun, 12 Jun 2011 16:20:36 +0200
On 06/12/2011 04:03 PM, Didier Raboud wrote:
> I'm hereby CC'ing the CUPS maintainers; opinions ?

I know about that problem and I will update the firmware upload script 
in the foo2zjs package soon, so that it also works with libusb.

   Till





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Sun, 12 Jun 2011 15:12:17 GMT) Full text and rfc822 format available.

Acknowledgement sent to Till Kamppeter <till.kamppeter@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Sun, 12 Jun 2011 15:12:18 GMT) Full text and rfc822 format available.

Message #22 received at 630228@bugs.debian.org (full text, mbox):

From: Till Kamppeter <till.kamppeter@gmail.com>
To: 630228@bugs.debian.org
Subject: Re: Bug#630228: Info received (Bug#630228: foo2zjs: Firmware upload is not compatible with cups)
Date: Sun, 12 Jun 2011 16:55:49 +0200
The fix is simple. The firmware uploader script needs to determine 
whether usblp is loaded or not, and if it is not loaded and the CUPS 
filter /usr/lib/cups/filter/usb exists, it should run a command line 
like this ("1020" replaced by actual model number):

for uri in `sudo /usr/lib/cups/backend/usb | grep -i 
'HP.*LaserJet.*1020' | grep -v FWVER | cut -d ' ' -f 2`; do echo $uri; 
sudo DEVICE_URI="$uri" /usr/lib/cups/backend/usb 1 1 1 1 '' 
/lib/firmware/hp/sihp1020.dl; done

This goes through all devices of the given model which do not have 
firmware loaded yet and load the firmware into them using the "usb" CUPS 
backend. As the usblp module is blacklisted by the CUPS package, this is 
sufficient to solve the problem.

   Till




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Sun, 12 Jun 2011 15:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Sun, 12 Jun 2011 15:33:03 GMT) Full text and rfc822 format available.

Message #27 received at 630228@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: 630228@bugs.debian.org
Subject: Re: Bug#630228: Info received (Bug#630228: foo2zjs: Firmware upload is not compatible with cups)
Date: Sun, 12 Jun 2011 16:29:36 +0100
[Message part 1 (text/plain, inline)]
On Sun, Jun 12, 2011 at 04:55:49PM +0200, Till Kamppeter wrote:
> The fix is simple. The firmware uploader script needs to determine
> whether usblp is loaded or not, and if it is not loaded and the CUPS
> filter /usr/lib/cups/filter/usb exists, it should run a command line
> like this ("1020" replaced by actual model number):
> 
> for uri in `sudo /usr/lib/cups/backend/usb | grep -i
> 'HP.*LaserJet.*1020' | grep -v FWVER | cut -d ' ' -f 2`; do echo
> $uri; sudo DEVICE_URI="$uri" /usr/lib/cups/backend/usb 1 1 1 1 ''
> /lib/firmware/hp/sihp1020.dl; done
> 
> This goes through all devices of the given model which do not have
> firmware loaded yet and load the firmware into them using the "usb"
> CUPS backend. As the usblp module is blacklisted by the CUPS
> package, this is sufficient to solve the problem.

Why is this not being done at a lower level, e.g. via udev or other
existing hotplug mechanisms?  Firmware-loading for /any/ device is
not the remit of cups, and it's really not cups' call to disable
any module loading.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Sun, 12 Jun 2011 15:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Till Kamppeter <till.kamppeter@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Sun, 12 Jun 2011 15:51:05 GMT) Full text and rfc822 format available.

Message #32 received at 630228@bugs.debian.org (full text, mbox):

From: Till Kamppeter <till.kamppeter@gmail.com>
To: debian-printing@lists.debian.org, Martin Pitt <martin.pitt@ubuntu.com>, 630228@bugs.debian.org
Subject: Re: Bug#630228: foo2zjs: Firmware upload is not compatible with cups
Date: Sun, 12 Jun 2011 17:49:04 +0200
On 06/12/2011 05:29 PM, Roger Leigh wrote:
> Why is this not being done at a lower level, e.g. via udev or other
> existing hotplug mechanisms?  Firmware-loading for /any/ device is
> not the remit of cups, and it's really not cups' call to disable
> any module loading.

Do you know a tool which can send the firmware file to a raw libusb 
device, so that using the CUPS backend for this is not necessary?

Note that upstream CUPS is only to be able to access the USB printers 
with one method, either usblp or libusb, not both. I suggested to use my 
patch for getting a hybrid usb backend upstream but Mike Sweet do not 
want to use it, he tells, usblp should be deprecated and only libusb 
should be used.

libusb is also the better method for modern multi-function devices. 
Especially HP uses libusb in their "hp" CUPS backend. So for a better 
consistency it is better to use only libusb in CUPS environments.

Therefore I want to deprecate usblp and switch software which still use 
it to use libusb.

   Till





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Tue, 14 Jun 2011 15:27:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Till Kamppeter <till.kamppeter@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Tue, 14 Jun 2011 15:27:05 GMT) Full text and rfc822 format available.

Message #37 received at 630228@bugs.debian.org (full text, mbox):

From: Till Kamppeter <till.kamppeter@gmail.com>
To: Peter De Wachter <pdewacht@gmail.com>, 630228@bugs.debian.org
Subject: Re: Bug#630228: foo2zjs: Firmware upload is not compatible with cups
Date: Tue, 14 Jun 2011 17:22:48 +0200
[Message part 1 (text/plain, inline)]
I have now updated the Ubuntu package (20110210dfsg-1ubuntu4) applying 
the attached patch. The patch modifies the firmware upload script 
hplj1000. It adds support for douing the firmware upload through the 
"usb" backend of CUPS. This makes the upload independent of the presence 
of usblp. It works also with the new libusb-based CUPS package.

   Till
[96-udev-firmware-script-cups-libusb-support.patch (text/x-patch, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Tue, 14 Jun 2011 15:54:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Till Kamppeter <till.kamppeter@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Tue, 14 Jun 2011 15:54:02 GMT) Full text and rfc822 format available.

Message #42 received at 630228@bugs.debian.org (full text, mbox):

From: Till Kamppeter <till.kamppeter@gmail.com>
To: 630228@bugs.debian.org
Subject: Bug#630228: foo2zjs: Firmware upload is not compatible with cups
Date: Tue, 14 Jun 2011 17:50:46 +0200
[Message part 1 (text/plain, inline)]
Small fix done on the patch ...

   Till
[96-udev-firmware-script-cups-libusb-support.patch (text/x-patch, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Printing Team <debian-printing@lists.debian.org>:
Bug#630228; Package foo2zjs. (Sun, 03 Jul 2011 15:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Lisandro Damián Nicanor Pérez Meyer <perezmeyer@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Printing Team <debian-printing@lists.debian.org>. (Sun, 03 Jul 2011 15:21:05 GMT) Full text and rfc822 format available.

Message #47 received at 630228@bugs.debian.org (full text, mbox):

From: Lisandro Damián Nicanor Pérez Meyer <perezmeyer@gmail.com>
To: 630228@bugs.debian.org, 630227@bugs.debian.org
Subject: Simple workaround for people with this bug
Date: Sun, 3 Jul 2011 12:18:54 -0300
[Message part 1 (text/plain, inline)]
Hi! This mail is just to document a simple way to work around this bug until a 
proper fix is applied.

Simply call /usr/sbin/hplj<your printer> as root, and the firmware will get 
loaded.

Regards, Lisandro.

-- 
Lisandro Damián Nicanor Pérez Meyer
http://perezmeyer.com.ar/
http://perezmeyer.blogspot.com/
[signature.asc (application/pgp-signature, inline)]

Reply sent to Didier Raboud <odyx@debian.org>:
You have taken responsibility. (Mon, 25 Jul 2011 17:03:17 GMT) Full text and rfc822 format available.

Notification sent to Peter De Wachter <pdewacht@gmail.com>:
Bug acknowledged by developer. (Mon, 25 Jul 2011 17:03:17 GMT) Full text and rfc822 format available.

Message #52 received at 630228-close@bugs.debian.org (full text, mbox):

From: Didier Raboud <odyx@debian.org>
To: 630228-close@bugs.debian.org
Subject: Bug#630228: fixed in foo2zjs 20110722dfsg-1
Date: Mon, 25 Jul 2011 17:02:40 +0000
Source: foo2zjs
Source-Version: 20110722dfsg-1

We believe that the bug you reported is fixed in the latest version of
foo2zjs, which is due to be installed in the Debian FTP archive:

foo2zjs_20110722dfsg-1.debian.tar.gz
  to main/f/foo2zjs/foo2zjs_20110722dfsg-1.debian.tar.gz
foo2zjs_20110722dfsg-1.dsc
  to main/f/foo2zjs/foo2zjs_20110722dfsg-1.dsc
foo2zjs_20110722dfsg-1_amd64.deb
  to main/f/foo2zjs/foo2zjs_20110722dfsg-1_amd64.deb
foo2zjs_20110722dfsg.orig.tar.bz2
  to main/f/foo2zjs/foo2zjs_20110722dfsg.orig.tar.bz2



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 630228@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Didier Raboud <odyx@debian.org> (supplier of updated foo2zjs package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Mon, 25 Jul 2011 17:53:17 +0200
Source: foo2zjs
Binary: foo2zjs
Architecture: source amd64
Version: 20110722dfsg-1
Distribution: unstable
Urgency: low
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Changed-By: Didier Raboud <odyx@debian.org>
Description: 
 foo2zjs    - Support for printing to ZjStream-based printers
Closes: 622125 630227 630228 632680 633870
Changes: 
 foo2zjs (20110722dfsg-1) unstable; urgency=low
 .
   New 20110525 upstream release.
 .
   [ Didier Raboud ]
   * DFSG repack
     - remove binary file c5200mono.prn
     - remove crd/qpdl/CLP* , because copyright is unclear
   * Uploaders:
     - Add myself.
     - Drop Steffen Joeris, with thanks for his past work.
   * Package relationships:
     - Demote cups and cups-client from Depends to Recommends (Closes: #622125).
       This allows one to use foo2zjs with lprng.
     - Add a Recommends on mscompress.
   * Patches:
     - Refresh all.
     - Update 30-udev-rules patch to cope with cups' usblp blacklisting.
     - Add 40-desktop-direct-launch.patch to remove the superfluous "wish"
       launch (avoids a lintian warning).
     - Update debian/patches/60-getweb.in.patch:
       Fix CVE-2011-2684 "Insecure Temporary File" (CWE-277) in
       /usr/bin/getweb by creating a safe temporary directory with mktemp.
       (Closes: #633870, LP: #805370)
     - Enhance 60-getweb.in.patch to forbid live update of /usr/bin/getweb as it
       is packaged. Also correct the typo in getweb. (Closes: #632680)
     - Update 60-hplj1000.patch to use the correct paths in kFreeBSD too.
     - Update 90-manpages.patch to fix more hyphen-used-as-minus mistakes.
     - Add 91-spelling-fixes.patch to fix 'precission' spelling mistake.
   * Convert to source format 3.0 (quilt)
   * Convert packaging to "tiny" dh7 style.
   * Migrate packaging to Git from Subversion, update Vcs-* fields.
   * Bump Standards-Version to 3.9.2 without changes needed.
 .
   [ Till Kamppeter ]
   * debian/rules: Added "-dNOINTERPOLATE" to the Ghostscript command lines to
     make Ghostscript rendering the pages significantly faster.
   * debian/patches/96-udev-firmware-script-cups-libusb-support.patch:
     Added support for uploading firmwae into printers using the USB backend of
     CUPS. This way the firmware upload also works without the usblp kernel
     module. (Closes: #630227, #630228)
   * debian/patches/95-udev-firmware-script-no-hplip-rules-removal.patch:
     Removed the lines in the UDEV script for the automatic firmware upload
     into the printer which remove the UDEV rules files for HPLIP's automatic
     firmware upload. (LP: #783389)
Checksums-Sha1: 
 f6d745546d6b5dbb50c4be5687d652c58d3c4ab8 1491 foo2zjs_20110722dfsg-1.dsc
 674732ac71dde5d55a64bf243c7555928c59430c 889944 foo2zjs_20110722dfsg.orig.tar.bz2
 ac4440790f97ba1220848ef4759d42d0b3bc334b 25457 foo2zjs_20110722dfsg-1.debian.tar.gz
 e76f30b69e6633c0916c80b32a851fa158b33b29 1782424 foo2zjs_20110722dfsg-1_amd64.deb
Checksums-Sha256: 
 45151d04ca2a7e4cdb661804829b44cfb569cf7d93c44c3e623528f056247333 1491 foo2zjs_20110722dfsg-1.dsc
 433f3f42bc9f741c84389afc480277746bd3771851de554a7cc0e62b69e66097 889944 foo2zjs_20110722dfsg.orig.tar.bz2
 7fad11eac171e23a25052d213063fa59306c377ed9bab0afa02965fa44d6c3ce 25457 foo2zjs_20110722dfsg-1.debian.tar.gz
 3952fc70c258a6a873fd8c9d0ef14e0193c00b6e1e62607d8e74faec70a0adb1 1782424 foo2zjs_20110722dfsg-1_amd64.deb
Files: 
 75c3043fa1f2c1e4dc64f6689eaebc06 1491 text optional foo2zjs_20110722dfsg-1.dsc
 65699a009b425fdf9db9a542a0a063b7 889944 text optional foo2zjs_20110722dfsg.orig.tar.bz2
 c4cf9423d04ccd56fb31768ce78d5409 25457 text optional foo2zjs_20110722dfsg-1.debian.tar.gz
 c06d1ccf6c0c9f2617c24f5a7b7d71ab 1782424 text optional foo2zjs_20110722dfsg-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iJwEAQECAAYFAk4tn08ACgkQKA1Vt+jBwDgmUwQAilDI2HG5yTI8hY4Zzy2rDOF3
FfYpK3wyh9cUZKKBHGW+hJEWPwgJ7tKAUZ4lUCNaTV4NemuMXds496nUkN6/ccc/
F7AYSMarM4YpUBswgszrlQxKjRmzxkefiPHTkPN4jgSeFl73JwLFZBoA5QJZYo3t
gc9R4ChOQzNBr/aJPAM=
=Ms3w
-----END PGP SIGNATURE-----





Reply sent to Didier Raboud <odyx@debian.org>:
You have taken responsibility. (Mon, 25 Jul 2011 17:03:17 GMT) Full text and rfc822 format available.

Notification sent to Guus Sliepen <guus@debian.org>:
Bug acknowledged by developer. (Mon, 25 Jul 2011 17:03:17 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 24 Aug 2011 07:31:03 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:12:05 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.